package org.eclipse.jdt.internal.compiler.parser.diagnose;

package .tmp;

import org.eclipse.jdt.internal.compiler.parser.diagnose.RangeUtil;

class RangeResult {
  private static final int INITIAL_SIZE = 10;
  
  int pos = 0;
  
  int[] intervalStarts = new int[10];
  
  int[] intervalEnds = new int[10];
  
  int[] intervalFlags = new int[10];
  
  void addInterval(int start, int end) {
    addInterval(start, end, 0);
  }
  
  void addInterval(int start, int end, int flags) {
    if (this.pos >= this.intervalStarts.length) {
      System.arraycopy(this.intervalStarts, 0, this.intervalStarts = new int[this.pos * 2], 0, this.pos);
      System.arraycopy(this.intervalEnds, 0, this.intervalEnds = new int[this.pos * 2], 0, this.pos);
      System.arraycopy(this.intervalFlags, 0, this.intervalFlags = new int[this.pos * 2], 0, this.pos);
    } 
    this.intervalStarts[this.pos] = start;
    this.intervalEnds[this.pos] = end;
    this.intervalFlags[this.pos] = flags;
    this.pos++;
  }
  
  int[][] getRanges() {
    int[] resultStarts = new int[this.pos];
    int[] resultEnds = new int[this.pos];
    int[] resultFlags = new int[this.pos];
    System.arraycopy(this.intervalStarts, 0, resultStarts, 0, this.pos);
    System.arraycopy(this.intervalEnds, 0, resultEnds, 0, this.pos);
    System.arraycopy(this.intervalFlags, 0, resultFlags, 0, this.pos);
    if (resultStarts.length > 1)
      quickSort(resultStarts, resultEnds, resultFlags, 0, resultStarts.length - 1); 
    return new int[][] { resultStarts, resultEnds, resultFlags };
  }
  
  private void quickSort(int[] list, int[] list2, int[] list3, int left, int right) {
    int original_left = left;
    int original_right = right;
    int mid = list[left + (right - left) / 2];
    while (true) {
      while (true) {
        if (compare(list[left], mid) >= 0) {
          while (compare(mid, list[right]) < 0)
            right--; 
          if (left <= right) {
            int tmp = list[left];
            list[left] = list[right];
            list[right] = tmp;
            tmp = list2[left];
            list2[left] = list2[right];
            list2[right] = tmp;
            tmp = list3[left];
            list3[left] = list3[right];
            list3[right] = tmp;
            left++;
            right--;
          } 
          if (left > right)
            break; 
          continue;
        } 
        left++;
      } 
      if (original_left < right)
        quickSort(list, list2, list3, original_left, right); 
      if (left < original_right)
        quickSort(list, list2, list3, left, original_right); 
      return;
    } 
    left++;
    continue;
  }
  
  private int compare(int i1, int i2) {
    return i1 - i2;
  }
}
